

import com.aspose.barcode.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.*;



public class AwtSample extends Panel implements TextListener, ItemListener, ActionListener 
{
	private static final long serialVersionUID = 1L;
	private Frame _frame;
	private TextField _codeText;	
	private TextField _xDimension;
	private TextField _rotationAngle;
	private Canvas _canvas;
	private Choice _symbology;
	private Button _print;
	private Button _save;
	private Checkbox _border; 
	
	public static void main(String args[])
		throws Exception
	{
		Frame f = new Frame("Aspose BarCode for Java 1.0 sample");
		f.add(new AwtSample(f));
		f.pack();
		f.setSize(400, 400);
		f.setVisible(true);
		f.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});
	}
	
	class MyCanvas extends Canvas
	{
		private BarCodeBuilder _bb = null;
		private static final long serialVersionUID = 1L;
		
		public BarCodeBuilder getBarCodeBuilder()
		{
			if(_bb == null)
			{
				return _bb = new BarCodeBuilder();
			}
			else
			{
				return _bb;
			}
		}
			
		public void paint(Graphics g)
		{
			this.getBarCodeBuilder().render(g);
			//this.setSize((int)this.getBarCodeBuilder().getWidth() + 1, (int)this.getBarCodeBuilder().getHeight() + 1);
		}
			
		public Dimension getPreferredSize()
		{
			return new Dimension(1200, 300);
		}
	}
	
	public void doPaint(Graphics g)
	{
		BarCodeBuilder b;
		b = new BarCodeBuilder();
		b.render(g);
	}
	
	public AwtSample(Frame f)
	{
		_frame = f;
		GridBagLayout l = new GridBagLayout();
		GridBagConstraints gc;
		Component com;
		int dy =0;
		
		setLayout(new FlowLayout(FlowLayout.LEFT));
		Panel panel = new Panel(l);
		add(panel);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		//placeholder
		l.setConstraints(com = new Label("                                                                                                      "), gc);
		panel.add(com);
				
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 0;
		gc.gridy = dy;
		l.setConstraints(com = new Label("CodeText:"), gc);
		panel.add(com);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(_codeText = new TextField(27), gc);
		_codeText.setText("12345678");
		_codeText.addTextListener(this);
		panel.add(_codeText);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 0;
		gc.gridy = dy;
		l.setConstraints(com = new Label("Symbology:"), gc);
		panel.add(com);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(_symbology = new Choice(), gc);
		_symbology.addItem("Code128");
		_symbology.addItem("Codabar");
		_symbology.addItem("Code11");
		_symbology.addItem("Code39Standard");
		_symbology.addItem("Code39Extended");
		_symbology.addItem("Code93Standard");
		_symbology.addItem("Code93Extended");
		_symbology.addItem("Standard2of5");
		_symbology.addItem("Interleaved2of5");
		_symbology.addItem("UPCA");
		_symbology.addItem("UPCE");
		_symbology.addItem("MSI");
		_symbology.addItemListener(this);
		panel.add(_symbology);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 0;
		gc.gridy = dy;
		l.setConstraints(com = new Label("xDimension:"), gc);
		panel.add(com);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(_xDimension = new TextField(27), gc);
		_xDimension.addTextListener(this);
		_xDimension.setText("0.6");
		panel.add(_xDimension);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 0;
		gc.gridy = dy;
		l.setConstraints(com = new Label("rotationAngle:"), gc);
		panel.add(com);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(_rotationAngle = new TextField(27), gc);
		_rotationAngle.addTextListener(this);
		_rotationAngle.setText("0");
		panel.add(_rotationAngle);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(_border = new Checkbox(), gc);
		_border.setLabel("Border");
		_border.setState(true);
		_border.addItemListener(this);
		panel.add(_border);		
		
		Panel buttons = new Panel();
		_print = new Button("Print");
		_print.addActionListener(this);
		_save = new Button("Save");
		_save.addActionListener(this);
		_save.setSize(100, 20);
		buttons.add(_save);
		buttons.add(_print);
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy++;
		l.setConstraints(buttons, gc);
		panel.add(buttons);		
		
		gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.WEST;
		gc.gridx = 1;
		gc.gridy = dy;
		l.setConstraints(_canvas = new MyCanvas(), gc);
		panel.add(_canvas);
		
		_canvas.repaint();
	}
	
	public void textValueChanged(TextEvent e)
	{
		TextComponent text = (TextComponent)e.getSource();
		try
		{
			if(text == _codeText)
			{
				((MyCanvas)_canvas).getBarCodeBuilder().setCodeText(_codeText.getText());
			}
			else if(text == _xDimension)
			{
				((MyCanvas)_canvas).getBarCodeBuilder().setXDimension(Float.parseFloat(_xDimension.getText()));
			}
			else if(text == _rotationAngle)
			{
				((MyCanvas)_canvas).getBarCodeBuilder().setRotationAngle(Float.parseFloat(_rotationAngle.getText()));
			}
			_canvas.repaint();
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	
	public void itemStateChanged(ItemEvent e)
	{
		try
		{
			if (e.getItemSelectable() == _symbology)
			{
				String symbology = (String) e.getItem();
				if(symbology.equals("Codabar"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODABAR);
				}
				else if(symbology.equals("Code11"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE11);
				}
				else if(symbology.equals("Code128"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE128);
				}
				else if(symbology.equals("Code39Standard"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE39STANDARD);
				}
				else if(symbology.equals("Code39Extended"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE39EXTENDED);
				}
				else if(symbology.equals("Code93Standard"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE93STANDARD);
				}
				else if(symbology.equals("Code93Extended"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.CODE93EXTENDED);
				}
				else if(symbology.equals("Interleaved2of5"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.INTERLEAVED2OF5);
				}
				else if(symbology.equals("Standard2of5"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.STANDARD2OF5);
				}
				else if(symbology.equals("UPCA"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.UPCA);
				}
				else if(symbology.equals("UPCE"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.UPCE);
				}
				else if(symbology.equals("MSI"))
				{
					((MyCanvas)_canvas).getBarCodeBuilder().setSymbology(Symbology.MSI);
				}
				this._canvas.repaint();
			}
			else if(e.getItemSelectable() == _border)
			{
				((MyCanvas)_canvas).getBarCodeBuilder().setBorderVisible(_border.getState());
				this._canvas.repaint();				
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public void actionPerformed(ActionEvent e)
	{
		try
		{
			if (e.getSource() == _print)
			{
				this.doPrint();
			}
			else if(e.getSource() == _save)
			{
				this.doSave();
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	private void doPrint()
	{
		PrintJob printJob = getToolkit().getPrintJob(_frame, "Print", null);
		if (printJob != null)
		{
			Graphics g = printJob.getGraphics();
			if (g != null)
			{
				((MyCanvas)_canvas).getBarCodeBuilder().render(g);
			}
			printJob.end();
		}
	}
	
	private void doSave()
		throws Exception
	{
		JFileChooser fc = new JFileChooser();
		String[] exts = ((MyCanvas)_canvas).getBarCodeBuilder().getSupportedImageFormats();
		for(int i=0; i<exts.length; i++)
		{
			Filter filter = new Filter(exts[i], exts[i] + " files");
			fc.addChoosableFileFilter(filter);
		}
		if(fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION)
		{
			((MyCanvas)_canvas).getBarCodeBuilder().save(fc.getSelectedFile().getPath());
		}
	}
	
	class Filter extends FileFilter
	{
		private String desc = "";
		private String ext = "";
		
		public Filter(String ext, String desc)
		{
			this.desc = desc;
			this.ext = ext;
		}
		
		public boolean accept(File f)
		{
			if(f.isDirectory() || f.getName().endsWith(this.ext))
			{
				return true;
			}
			return false;
		}
		public String getDescription()
		{
			return this.desc;
		}
	}
}  
